/*
 *
 *   qrash: the second portable demo in the world
 *
 *   Copyright (C) 1997  Queue Members Group Art Division
 *   Coded by Mad Max / Queue Members Group (Mike Shirobokov)
 *   <mad_max@qmg.rising.ru>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 * 
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 */


#ifdef _XBOX 
	#include <io.h>
#endif

#ifndef _WIN32_WCE
	#include <fcntl.h>
	#include <unistd.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include "zlib/zlib.h"

struct entry {
  char name[16];
  int offset, size;
} *table=0;

void main( int argc, char* argv[] )
{
  FILE* f = fopen( argv[1], "r" );
  if(f) {
    fseek( f, -4, SEEK_END );
    int n;
    fread( &n, 1, sizeof(int), f );
    if( n == 0x12345678 ) {
      fseek( f, -8, SEEK_END );
      fread( &n, 1, sizeof(int), f );
      fseek( f, n, SEEK_SET );
      int resource_number;
      fread( &resource_number, 1, sizeof(int), f );
      table = (entry*)malloc(sizeof(entry)*resource_number);
      fread( table, 1, sizeof(entry)*resource_number, f );
      for( int i=0; i<resource_number; i++ ) {
		printf( "name=%s offset=%d size=%d\n",
		table[i].name, table[i].offset, table[i].size );
		FILE* f1 = fopen( table[i].name, "wb" );
		void* buf = malloc( table[i].size );
		fseek( f, table[i].offset, SEEK_SET );
		fflush(f);
		gzFile gzf = gzdopen( (int)fileno(f), "rb" );
		gzread( gzf, buf, table[i].size );
		gzclose(gzf);
		fwrite( buf, 1, table[i].size, f1 );
		free(buf);
		fclose(f1);
      }
    }
    fclose(f);
  }
}
