/*
 *
 *   qrash: the second portable demo in the world
 *
 *   Copyright (C) 1997  Queue Members Group Art Division
 *   Coded by Mad Max / Queue Members Group (Mike Shirobokov)
 *   <mad_max@qmg.rising.ru>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 * 
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string>
#include "video.h"
#include "misc.h"
#include "music.h"
#include <windows.h>
#include <gx.h>

#define vidScreenPtr	((uchar*)videoMem)

PAGE current_page = 0;

extern HWND hwnd;
extern HINSTANCE hInstance;

int x_pitch;

void vidDoInitVideo() {
    GXOpenDisplay( hwnd, NULL );
}

void vidSetVideoMode( int num ) {
    GXDisplayProperties dp = GXGetDisplayProperties();
    vidSizeX = dp.cyHeight;
    vidSizeY = dp.cxWidth;
    vidBytesPerLine = vidSizeX;
    x_pitch = dp.cbyPitch;
    vidPageSize = vidBytesPerLine*vidSizeY;
    vidMaxPage = 1;
    current_page = vidAllocPage();
    GXSetViewport( 0, dp.cyHeight, 0, 0 );
    vidInitialized = true;
}

void vidDoCloseVideo() {
    GXCloseDisplay();
    current_page = 0;
}


int vidChooseVideoMode() {
  return 0;
}

void vidDoSetPalette( vidRGB* pal, int border )
{
//	debug( "vidDoSetPalette" );
//	memcpy( cur_pal, pal, sizeof(vidRGB)*256 );
}

void vidShowPage( uchar* page )
{
//	debug( "vidShowPage" );
	short* screen = (short*)GXBeginDraw();
	if( !screen ) error( "Cannot get the framebuffer pointer" );
	for( int x=vidSizeX-1; x>=0; x-- ) {
		for( int y=0; y<vidSizeY; y++ ) {
			vidRGB* pix = vidCurrentPalette + page[ vidBytesPerLine*y + x ];
			screen[y] = ( int( pix->r & 0xF8 ) << 8 ) | ( int( pix->g & 0xFC ) << 3 ) | ( pix->b >> 3 );
		}
		screen += x_pitch/2;
	}
	GXEndDraw();
}

void vidDoShowPage( PAGE color, PAGE bw, uchar* dither_table )
{
//	debug( "vidDoShowPage" );
  vidDitherPage( color, bw, current_page, dither_table );
  vidShowPage((PAGE)current_page);
}

void vidMessage( char* msg )
{
//	FILE* f = fopen( "E:\\Apps\\qrash\\qrash.log", "a" );
	FILE* f = fopen( "qrash_log.txt", "a" );
	fputs( msg, f );
	fclose( f );
}
